unit MAIN;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Card, StdCtrls, ExtCtrls, Menus, ActnList, Spin, BmDelay, IniFiles;

type
  TfmMAIN = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Panel5: TPanel;
    lblNumber: TLabel;
    mmMAIN: TMainMenu;
    lblStatus: TLabel;
    G: TMenuItem;
    GNew: TMenuItem;
    ActionList1: TActionList;
    actNew: TAction;
    lblBookMark: TLabel;
    Image1: TImage;
    btnNew: TButton;
    GOption: TMenuItem;
    actOption: TAction;
    lblCard: TLabel;
    BmDelay1: TBmDelay;
    lblSCR0: TLabel;
    lblSCR1: TLabel;
    lblSCR2: TLabel;
    lblSCR3: TLabel;
    actHowPlay: TAction;
    GHowPlay: TMenuItem;
    actHIGH: TAction;
    GHIGH: TMenuItem;
    GAbout: TMenuItem;
    actAbout: TAction;
    lblMessage: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure actHowPlayExecute(Sender: TObject);
    procedure actHIGHExecute(Sender: TObject);
    procedure actNewExecute(Sender: TObject);
    procedure actAboutExecute(Sender: TObject);
    procedure actOptionExecute(Sender: TObject);
  private
    { Private declarations }
    procedure NewGame;
    function CardNum(ID: Integer; var Value: TCardValue; var Suit: TCardSuit): Boolean;
    procedure RandCard;
    procedure ShowCard(UserNum: Integer);
    function GetCardID: Integer;
    procedure ComCard;
    procedure ComAI;
    procedure aDockCard(cCard: TCard; UpdateCard: Boolean);
    procedure ClearPanel5;
    procedure ClearAllCard;
    procedure ClearUserCard(User: Integer);
    procedure ShowNumber(num: Integer);
    function CheckCanUse(User: Integer): Boolean;
    function CheckWinner: Integer;
    function CountSCR(User: Integer): Integer;
    procedure UserClick(CanUse: Boolean);
  public
    { Public declarations }
    procedure CardClick(Sender: TObject);
    procedure CardClickCancel(Sender: TObject);
    function PosDeckType(DeckType: TDecks): Integer;
  end;

var
  fmMAIN: TfmMAIN;
  aX, tCardnum, aUserID: Integer;
  aUser, cBookmark: Integer;
  aShow: Boolean;
  aDockX: Integer;
  aTime1, aTime2, aTime3: Integer;
  aDeckType: TDecks;
{
  aUserID := 0;    ثeϥΪID
  aUser := 1;      iV (1 or -1)
  cBookmark        nCard P
  aShow            ܵP
  aDockX           bWXPX
}
  nCard: array[0..51] of Integer;
  uCard: array[0..15] of TCard;  // ŧiUser Card
  xCard: array[0..3] of Boolean; // iXPFlag
  sCard: array[0..3] of Integer; // ĹP

implementation

uses HOWPLAY, HIGH, USER, ABOUT, OPTION;

{$R *.DFM}
procedure TfmMAIN.UserClick(CanUse: Boolean);
var i: Integer;
begin
  if xCard[0] then
  begin
    for i := 0 to 3 do
    begin
      if CanUse then
        uCard[i].OnClick := CardClick
      else
        uCard[i].OnClick := CardClickCancel;
    end;
  end;
end;

function TfmMAIN.CountSCR(User: Integer): Integer;   // p⦨Z
var i, j, k: Integer;
begin
  j := -1;
  k := 0;
  if (User >= 0) and (User <= 3) then
  begin
    for i := 0 to 3 do
      if not xCard[i] then j := j + 1;

    case j of
      -1: k := 0;
       0: k:= -500;
       1: k := -300;
       2: k := -200;
       3: k := 1000;
       4: k := 0;
    end;
    sCard[User] := sCard[User] + k;
    TLabel(FindComponent('lblSCR' + FormatFloat('0', User))).Caption := FormatFloat('###,###', sCard[User]);
  end;
  Result := k;
end;

function TfmMAIN.CheckWinner: Integer;
var i, j, k: Integer;
begin
  j := 0;
  k := -1;
  for i := 0 to 3 do
  begin
    if xCard[i] then
    begin
      j := j + 1;
      k := i;
    end;
  end;
  if (j = 1) then
    Result := k
  else
    Result := -1;
end;

procedure TfmMAIN.CardClick(Sender: TObject);
var k, tNum: Integer;
begin
  // User XP
  if xCard[0] then
  begin
    tNum := StrToInt(lblNumber.Caption);
    k := StrToInt(Copy(TCard(Sender).Name, 6, 1));
    if (uCard[k].Value <> 4) and
       (uCard[k].Value <> 10) and
       (uCard[k].Value <> 11) and
       (uCard[k].Value <> 12) and
       (uCard[k].Value <> 13) then
    begin
      if (tNum + uCard[k].Value) > 99 then
      begin
        ShowMessage('You can not choice');
        Exit;
      end;
    end;
    
    uCard[k].Visible := False;
    aDockCard(uCard[k], True);    // NPbW
    ShowCard(k);
  end else
    Exit;

  // qXP
  aUserID := aUserID + aUser;
  if (aUserID > 3) then aUserID := 0;
  if (aUserID < 0) then aUserID := 3;
  ComCard;
end;

// ˬdO_PiX
function TfmMAIN.CheckCanUse(User: Integer): Boolean;
var i, tNum: Integer;
    Ok: Boolean;
begin
  Ok := False;
  tNum := StrToInt(lblNumber.Caption);
  if (User >= 0) and (User <= 3) then
  begin
    if xCard[User] then
    begin
      for i := (User*4) to (User * 4) + 3 do
      begin
        if (uCard[i].Value = 4) or
           (uCard[i].Value = 10) or
           (uCard[i].Value = 11) or
           (uCard[i].Value = 12) or
           (uCard[i].Value = 13) then
          Ok := True
        else
          if (tNum + uCard[i].Value) <= 99 then Ok := True;
      end;
    end;
  end else
    ShowMessage('CheckCanUse(UserID) Value not 0 - 3');
  Result := Ok;
end;

procedure TfmMAIN.ShowNumber(num: Integer);
begin
  lblNumber.Font.Color := clBlack;
  lblNumber.Caption := FormatFloat('00', num);
  if (num = 99) then
    lblNumber.Font.Color := clRed;
end;

procedure TfmMAIN.ClearUserCard(User: Integer);
var i: Integer;
begin
  if (User >= 0) and (User <= 4) then
  begin
    if (User = 4) then
    begin
      // R
      for i := 15 downto 0 do
      begin
        if Assigned(uCard[i]) then
        begin
          uCard[i].Free;
          uCard[i] := nil;
        end;
      end;
    end else
    begin
      // RwUser
      for i := (User * 4) + 3 downto (User*4) do
      begin
        if Assigned(uCard[i]) then
        begin
          uCard[i].Free;
          uCard[i] := nil;
        end;
      end;
    end;
  end;
end;

procedure TfmMAIN.ClearAllCard;
var i: Integer;
begin
  for i := ComponentCount -1 downto 0 do
  begin
    if (Components[i] is TCard) then
      TCard(Components[i]).Free;
  end;
end;

procedure TfmMAIN.ClearPanel5;
var i: Integer;
begin
 for i := ComponentCount -1 downto 0 do
  begin
    if (Components[i] is TCard) then
      if (TCard(Components[i]).Parent = Panel5) then
      begin
        TCard(Components[i]).Free;
        BmDelay1.WaitForDelay(aTime1);
      end;
  end;
end;

procedure TfmMAIN.aDockCard(cCard: TCard; UpdateCard: Boolean);
var bCard: TCard;
    tNum, cNum: Integer;
begin
  try
    cCard.Visible := False;
    if UpdateCard then
    begin
      tNum := StrToInt(lblNumber.Caption);
      cNum := 0;  // [ƥ
      case cCard.Value of
        4:
         begin
           if (aUser > 0) then
           begin
             aUser := -1;
             Image1.Picture.LoadFromFile('a2.bmp');
           end else
           begin
             aUser := 1;
             Image1.Picture.LoadFromFile('a1.bmp');
           end;
           lblMessage.Caption := 'RETURN';
         end;
        10:
         begin
           if (tNum + 10) > 99 then
           begin
             cNum := -10;
             lblMessage.Caption := '- 10';
           end else
           begin
             cNum := 10;
             lblMessage.Caption := '+ 10';
           end;
         end;
        11: lblMessage.Caption := 'Pass';
        12:
         begin
           if (tNum + 20) > 99 then
           begin
             cNum := -20;
             lblMessage.Caption := '- 20';
           end else
           begin
             cNum := 20;
             lblMessage.Caption := '+ 20';
           end;
         end;
        13:
         begin
           tNum := 99;
           lblMessage.Caption := '99';
         end;
      else
        cNum := cCard.Value;
      end;
      tNum := tNum + cNum;
      ShowNumber(tNum);
    end;

    bCard := TCard.Create(Self);
    bCard.Parent := Panel5;
    bCard.Top := 8;
    bCard.Left := aDockX;
    bCard.Suit := cCard.Suit;
    bCard.Value := cCard.Value;

    if UpdateCard then
      BmDelay1.WaitForDelay(aTime2)
    else
      BmDelay1.WaitForDelay(100);

    aDockX := aDockX + 15;
    if (aDockX > 410) then
    begin
      aDockX := 8;
//      ClearPanel5;
    end;
  except
    bCard.Free;
  end;
  cCard.Visible := True;
end;

procedure TfmMAIN.ComAI;    // qHuzXPP_
var i, j, xCount, kCount, User, tNum: Integer;
    k: Integer;
    Ok: Boolean;
 procedure CardK(var Ok: Boolean; var k: Integer; var j: Integer);
 var i: Integer;
 begin
   // PXPu J 4 K 10 Q
   for i := (User*4) to (User * 4) + 3 do
   begin
     if (uCard[i].Value = 11) or
        (uCard[i].Value = 4) then
     begin
       Ok := True;
       k := i;
       j := 0;
       Break;
     end;
     if (uCard[i].Value = 13) then
     begin
       Ok := True;
       k := i;
       J := 99;
     end;
     if (uCard[i].Value = 10) and
        (j < 99) then
     begin
       Ok := True;
       k := i;
       J := -10;
     end;
     if (uCard[i].Value = 12) and
        (j < 99) and (j > -10) then
     begin
       Ok := True;
       k := i;
       J := -20;
     end;
   end;
  end;
begin
  Ok := False;   // PiX
  k := -1;       // XPs ( 0 - 15)
  j := 0;        // [I
  User := aUserID;
  xCount := 0;     // Pi
  kCount := 0;     // Ki

  tNum := StrToInt(lblNumber.Caption);

  if not CheckCanUse(User) then
  begin
    if xCard[User] then
    begin
      aDockX := aDockX + 15;
      if (aDockX > 415) then
      begin
        aDockX := 8;
      end;

      for i := (User * 4) + 3 downto (User*4) do
        aDockCard(uCard[i], False);    // NPbW

      ClearUserCard(User);

      aDockX := aDockX + 15;
      if (aDockX > 415) then
      begin
        aDockX := 8;
      end;

      xCard[User] := False;
      CountSCR(User);
      Exit;
    end;
  end;

  if xCard[User] then
  begin
    for i := (User*4) to (User * 4) + 3 do
    begin
      // Pi
      if (uCard[i].Value = 4) or
         (uCard[i].Value = 10) or
         (uCard[i].Value = 11) or
         (uCard[i].Value = 12) or
         (uCard[i].Value = 13) then
      begin
        xCount := xCount + 1;
        if (uCard[i].Value = 13) then kCount := kCount + 1;
      end;
    end;

    // GiHWPBKP
    if (xCount >= 2) and (tNum < 99) then
    begin
      if (kCount > 0) then
      begin
        for i := (User*4) to (User * 4) + 3 do
        begin
          if (uCard[i].Value = 13) then
          begin
            Ok := True;
            k := i;
            j := 99;
          end;
        end;
      end;

      // P10 Q i[99
      for i := (User*4) to (User * 4) + 3 do
      begin
        if ((uCard[i].Value = 10) and
           ((tNum+10) = 99)) or
           ((uCard[i].Value = 12) and
           ((tNum+20) = 99)) then
        begin
          Ok := True;
          k := i;
          j := 10;
          if (uCard[i].Value = 12) then j:= 20;
        end;
      end;
    end;

    // `IƬ99ɤ@wnXP
    if (tNum = 99) then
    begin
      CardK(Ok, k, j);
    end;

    if not Ok then
    begin
      // p99X̤jIƵP
      for i := (User*4) to (User * 4) + 3 do
      begin
        if ((uCard[i].Value + tNum) <= 99) and
           (uCard[i].Value <> 4) and
           (uCard[i].Value <> 10) and
           (uCard[i].Value <> 11) and
           (uCard[i].Value <> 12) and
           (uCard[i].Value <> 13) then
        begin
          if (uCard[i].Value > j) then
          begin
            Ok := True;
            k := i;
            j := uCard[i].Value;
          end;
        end;
      end;
    end;

    // ٬OSPX, XP
    if not Ok then
    begin
      CardK(Ok, k, j);
    end;
  end;

  if Ok then
  begin
    aDockCard(uCard[k], True); // NPbW
    ShowCard(k);               // @isP
{
    ShowMessage('User ID:' + FormatFloat('0', aUserID) + #13 +
                'Card Num:' + FormatFloat('00', k) + #13 +
                'Card Value:' + FormatFloat('00', j));
}
  end;
end;

procedure TfmMAIN.ComCard;  // qXP
var u, i, j, intHigh: Integer;
    strWin, strTemp, strUserName: String;
    HighIni: TIniFile;
begin
  while True do
  begin
    // ˬdO_uѤ@User
    u := CheckWinner;
    if (u >= 0) then
    begin
      strWin := '';
      case u of
        0: strWin := 'User';
        1: strWin := 'Com1';
        2: strWin := 'Com2';
        3: strWin := 'Com3';
      end;
      lblStatus.Caption := 'Winner is ' + strWin;

      xCard[u] := False;
      CountSCR(u);

      // User ĹF令Z
      if (u = 0) then
      begin
        HighIni := TIniFile.Create('HIGH.INI');
        with HighIni do
        begin
          for i := 1 to 10 do
          begin
            strTemp := 'HIGH' + FormatFloat('00', i);
            if SectionExists(strTemp) then
            begin
              intHigh := ReadInteger(strTemp, 'Level', 0);
              if (sCard[u] > intHigh) then
              begin
                strUserName := ReadString(strTemp, 'UserID', 'noname');
                fmUSER.SetDataValue(strUserName, i, sCard[u]);
                WriteString(strTemp, 'UserID', strUserName);
                WriteInteger(strTemp, 'Level', sCard[u]);
                Break;
              end;
            end;
          end;
          Free;
        end;
      end;

      actNew.Enabled := True;
      Abort;
      Exit;
    end;

    // UserXP
    if (aUserID = 0) then
    begin
      UserClick(True);
      if xCard[aUserID] and not CheckCanUse(aUserID) then
      begin
        // LPiX
        xCard[aUserID] := False;
        CountSCR(aUserID);

        for u := 0 to 3 do
          aDockCard(uCard[u], False);    // NPbW

        ClearUserCard(aUserID);
        Panel1.Caption := 'You lost !';
        aShow := False;
        // ܨLϥΪ̪P
        for i := 1 to 3 do
        begin
          if xCard[i] then
          begin
            for j := (i*4) to (i * 4) + 3 do
            begin
              uCard[j].ShowDeck := False;
              BmDelay1.WaitForDelay(15);
            end;
          end;
        end;
      end;

      if xCard[aUserID] then
      begin
        lblStatus.Caption := 'Your choice';
        Break;
      end;
    end else
      UserClick(False);

    ComAI;

    aUserID := aUserID + aUser;
    if (aUserID > 3) then aUserID := 0;
    if (aUserID < 0) then aUserID := 3;
  end;
end;

function TfmMAIN.GetCardID: Integer;
var Value: Integer;
begin
  Value := 0;
  while True do
  begin
    // Pwo~P
    if (cBookmark > 51) then
    begin
      ClearPanel5;
      RandCard;
      cBookmark := 0;
      aDockX := 8;
    end;

    lblCard.Caption := 'Card:' + FormatFloat('00', cBookmark+1);
    if (nCard[cBookmark]) > 0 then
    begin
      Value := nCard[cBookmark];
      cBookmark := cBookmark + 1;
      Break;
    end else
    begin
      cBookmark := cBookmark + 1;
    end;
  end;
  Result := Value;
end;

procedure TfmMAIN.ShowCard(UserNum: Integer);
var User, CardID: Integer;
    CardValue: TCardValue;
    CardSuit: TCardSuit;
    tmpCard: TCard;
begin
  // UserNum XPm
  if (UserNum >= 0) and (UserNum <= 15) then
  begin
    // iXPUser
    User := UserNum div 4;
    if xCard[User] then
    begin
      tmpCard := uCard[UserNum];
      if Assigned(tmpCard) then
        uCard[UserNum].Visible := False;

      CardID := GetCardID;  // GetCardID U@iP

      if Assigned(tmpCard) then
        uCard[UserNum].Visible := True;

      CardNum(CardID, CardValue, CardSuit);
      try
        if not Assigned(tmpCard) then
          uCard[UserNum] := TCard.Create(Self);
        case User of
          0: uCard[UserNum].Parent := Panel1;
          1: uCard[UserNum].Parent := Panel2;
          2: uCard[UserNum].Parent := Panel3;
          3: uCard[UserNum].Parent := Panel4;
        end;
        uCard[UserNum].DeckType := aDeckType;
        if (User > 0) then
          uCard[UserNum].ShowDeck := aShow
        else
        begin
          uCard[UserNum].Name := 'uCard' + FormatFloat('0', UserNum);
          uCard[UserNum].Cursor := crHandPoint;
          uCard[UserNum].OnClick := CardClick;
        end;
        uCard[UserNum].Top := 24;
        uCard[UserNum].Left := ((UserNum mod 4) * 73) + 8;
        uCard[UserNum].Suit := CardSuit;
        uCard[UserNum].Value := CardValue;
      except
        uCard[UserNum].Free;
      end;
      BmDelay1.WaitForDelay(aTime3);
    end;
  end else
    ShowMessage('UserNum Value not in 0 - 15');
end;

procedure TfmMAIN.RandCard;
var i, j, k, t: Integer;
    CardValue: TCardValue;
    CardSuit: TCardSuit;
    tmpCard: TCard;
begin
  for i := 0 to 51 do
  begin
    nCard[i] := i + 1;
    CardNum(nCard[i], CardValue, CardSuit);
    for j := 0 to 15 do
    begin
      tmpCard := uCard[j];
      if Assigned(tmpCard) then
      begin
        if (uCard[j].Value = CardValue) and
           (uCard[j].Suit = CardSuit) then
        begin
          nCard[i] := 0;
          Break;
        end;
      end;
    end;
  end;

  // üƬ~P 666 
  Randomize;
  for i := 1 to 666 do
  begin
    j := Random(52);
    k := Random(52);
    // 洫 j<->k
    t := nCard[j];
    nCard[j] := nCard[k];
    nCard[k] := t;
  end;
end;

function TfmMAIN.CardNum(ID: Integer; var Value: TCardValue; var Suit: TCardSuit): Boolean;
var CardID, CardSuit: Integer;
    Ok: Boolean;
begin
  // 01 - 13 Spades
  // 14 - 26 Diamonds
  // 27 - 39 Clubs
  // 40 - 52 Hearts
  Ok := False;
  CardSuit := ((ID - 1) div 13);
  CardID := (ID - 1) mod 13 + 1;
  if (CardID >= 1) and (CardID <= 13) then
  begin
    if (CardSuit >= 0) and (CardSuit <= 3) then
    begin
      Value := CardID;
      Suit := TCardSuit(CardSuit);
      Ok := True;
    end;
  end;
  Result := Ok;
end;

procedure TfmMAIN.NewGame;
var i: Integer;
begin
  actNew.Enabled := False;

  aX := 8;
  aDockX := 8;
  tCardnum := 0;
  cBookmark := 0;  // nCard P
  aUserID := 0;    // ثeϥΪID
  aUser := 1;      // iV (1 or -1)
  aShow := True;   // ܵP
  Image1.Picture.LoadFromFile('a1.bmp');
  lblStatus.Caption :='New Game';
  lblMessage.Caption := '';

  ShowNumber(tCardnum);
  ClearUserCard(4);  // MUser TCard
  ClearPanel5;       // MPanel5 W TCard

  RandCard;

  for i := 0 to 3 do
  begin
    xCard[i] := True;  // iXP
    TPanel(FindComponent('Panel' + FormatFloat('0', i + 1))).Caption := '';
  end;

  for i := 0 to 3 do
    CountSCR(i);

  aUserID := Random(4);  // Ĥ@ӥXP
  lblBookMark.Caption := 'First User:' + FormatFloat('0', aUserID);

  // o|aP
  for i := 0 to 15 do
  begin
    ShowCard(i);
  end;

  // qXP
  ComCard;
end;

procedure TfmMAIN.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ClearAllCard;
end;

procedure TfmMAIN.FormCreate(Sender: TObject);
var i: Integer;
    strTemp: String;
    HighIni: TIniFile;
begin
  // Y䤣HIGH.INIh(eWZ)
  HighIni := TIniFile.Create('HIGH.INI');
  with HighIni do
  begin
    for i := 1 to 10 do
    begin
      strTemp := 'HIGH' + FormatFloat('00', i);
      if not SectionExists(strTemp) then
      begin
        WriteString(strTemp, 'UserID', 'User' + FormatFloat('00', i));
        WriteInteger(strTemp, 'Level', ((11 - i) * 2000) + 50000);
      end;
    end;
    if not SectionExists('OPTION') then
    begin
      aTime1 := 5;
      aTime2 := 200;
      aTime3 := 50;
      aDeckType := Standard2;

      WriteInteger('OPTION', 'TIME1', aTime1);
      WriteInteger('OPTION', 'TIME2', aTime2);
      WriteInteger('OPTION', 'TIME3', aTime3);
      WriteInteger('OPTION', 'DeckType', PosDeckType(aDeckType));
    end;
    aTime1 := ReadInteger('OPTION', 'TIME1', 5);
    aTime2 := ReadInteger('OPTION', 'TIME2', 200);;
    aTime3 := ReadInteger('OPTION', 'TIME3', 50);;
    aDeckType := TDecks(ReadInteger('OPTION', 'DeckType', 0));
    Free;
  end;

  lblStatus.Caption := '';
  lblBookMark.Caption := '';
  lblCard.Caption := '';
  lblMessage.Caption := '';
  
  for i := 0 to 3 do
  begin
    xCard[i] := True;
    sCard[i] := 50000;
  end;

  for i := 0 to 3 do
    CountSCR(i);
    
  for i := 1 to 5 do
  begin
    TPanel(FindComponent('Panel' + FormatFloat('0', i))).Caption := '';
  end;
end;

procedure TfmMAIN.actHowPlayExecute(Sender: TObject);
begin
  fmHowPlay.ShowModal;
end;

procedure TfmMAIN.actHIGHExecute(Sender: TObject);
begin
  fmHIGH.ShowModal;
end;

procedure TfmMAIN.actNewExecute(Sender: TObject);
begin
  NewGame;
end;

procedure TfmMAIN.actAboutExecute(Sender: TObject);
begin
  fmAbout.ShowModal;
end;

procedure TfmMAIN.CardClickCancel(Sender: TObject);
begin
  // Disable CarClick
end;

procedure TfmMAIN.actOptionExecute(Sender: TObject);
var i: Integer;
    tmpCard: TCard;
begin
  fmOPTION.ShowModal;
  for i := 4 to 15 do
  begin
    tmpCard := uCard[i];
    if Assigned(tmpCard) then
      uCard[i].DeckType := aDeckType;
  end;
end;

function TfmMAIN.PosDeckType(DeckType: TDecks): Integer;
var i: Integer;
begin
  for i := 0 to 11 do
  begin
    if (DeckType = TDecks(i)) then
      Break;
  end;
  Result := i;
end;

end.
